package w2phtml.pageSplitters;

import static w2phtml.office.XMLString.TABLE_TABLE_ROW;
import static w2phtml.office.XMLString.TEXT_SOFT_PAGE_BREAK;

import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import w2phtml.office.OfficeReader;

public class TableRowsSplitter extends BasicSplitter implements ISplitter {

	public TableRowsSplitter(OfficeReader officeReader, SplitFactory factory) {
		super(officeReader, factory);
	}

	@Override
	public SplitResults Split(Node tableRows) {
		Node tableRowsFirstPart = tableRows.cloneNode(false);
		Node parent = tableRows.getParentNode();
		SplitResults results = new SplitResults(false);
		// Node counter
		int i = 0;
		NodeList tableRowsChildNodes = tableRows.getChildNodes();
		while (tableRowsChildNodes.getLength() > i) {
			Node tableRowsChildNode = tableRowsChildNodes.item(0);
			if ((tableRowsChildNode.getNodeType() == Node.ELEMENT_NODE)) {
				
				String nodeName = tableRowsChildNode.getNodeName();
				
				if (containsSPB(tableRowsChildNode)){
					if (nodeName.equals(TEXT_SOFT_PAGE_BREAK)){
						// remove inner soft page break node
						tableRows.removeChild(tableRowsChildNode);
					
					} else if (nodeName.equals(TABLE_TABLE_ROW)){
						if (factory.split(tableRowsChildNode).isDataMoved()){
							results.setDataMoved(true);
							tableRowsFirstPart.appendChild(tableRowsChildNode.getPreviousSibling());
						}
					} 
					break;
				} else {
					tableRowsFirstPart.appendChild(tableRowsChildNode);
					results.setDataMoved(true);
				}
			} else {
				System.out.println("ERROR: TEXT NODE FOUND INSIDE tabl:table-rows");
				//Append text nodes
				//tableRowsFistPart.appendChild(tableRowsChildNode);
				//dataMoved = true;	
			}
			
		}
		if (results.isDataMoved()) {
			parent.insertBefore(tableRowsFirstPart, tableRows);
		}
		return results;
	}

}
